#include "ACmpl.hpp"
#include <stdio.h>
#include "ECmplLng.h"

char *AcceptKeyText; // - - GetKey  
                     //  -  AcceptKey

long WINAPI GetKey( HANDLE hDlg, int Msg, int Param1, long Param2 );

TAutoCompletion::TAutoCompletion(void)
{
    Word[0] = 0;

    WorkInsideWord = FALSE;
    CaseSensitive = TRUE;
//    BrowseDownward = TRUE;
    ConsiderDigitAsChar = FALSE;
//    AddTrailingSpace = FALSE;

//    BrowseLineCnt = 500;
    MinPreWordLen = 2;
    WordsToFindCnt = 3;

    AcceptFromMenu = FALSE;
    PartialCompletion = TRUE;

    AcceptKey = VK_TAB;
    Color = 0x2F;

    WordCount = 0;
    WordList = NULL;

    AutoAdded = 0;
    RewritedText[0] = 0;

    CheckCursor=false;

    strcpy( RegKey, "AutoCompletion" );
    strcpy( ConfigHelpTopic, "ConfigAuto" );

    DialogItemsCnt = ACMPL_DIALOG_ITEMS;

    DialogWidth = 46;
    DialogHeight = 25;
};

TAutoCompletion::~TAutoCompletion()
{
    ;
};

void TAutoCompletion::GetOptions(void)
{
    TCompletion::GetOptions( );

    Color          = GetRegKey( HKEY_CURRENT_USER, RegKey, "Color", Color );
    AcceptKey      = GetRegKey( HKEY_CURRENT_USER, RegKey, "AcceptKey", AcceptKey );
    AcceptFromMenu = GetRegKey( HKEY_CURRENT_USER, RegKey, "AcceptFromMenu", AcceptFromMenu );
    Validate( );
};

void TAutoCompletion::SetOptions(void)
{
    TCompletion::SetOptions( );

    Validate( );
    SetRegKey( HKEY_CURRENT_USER, RegKey, "Color", Color );
    SetRegKey( HKEY_CURRENT_USER, RegKey, "AcceptKey", AcceptKey );
    SetRegKey( HKEY_CURRENT_USER, RegKey, "AcceptFromMenu", AcceptFromMenu );
};

void TAutoCompletion::Validate(void)
{
    TCompletion::Validate( );

    AcceptFromMenu = AcceptFromMenu ? TRUE : FALSE;
};

DWORD WINAPI SearchThread(LPVOID lpvThreadParm)
{
  TAutoCompletion *cmpl=static_cast<TAutoCompletion *>(lpvThreadParm);
  return cmpl->DoSearch();
}


BOOL TAutoCompletion::PutVariant(void)
{
    struct EditorInfo ei;
    FarMenuItem TmpWordList[MAX_WORD_CNT];
    DWORD SearchOk=FALSE;

    DeleteVariant( );

    EditorControl(ECTL_GETINFO,&ei);

    if( GetPreWord() )
    {
        WordList = TmpWordList;

        WordsToFindCnt++;

        { // start thread
          HANDLE handles[2];
          DWORD ThreadID;
          Stop=FALSE;
          handles[0]=CreateThread(NULL,0,SearchThread,this,CREATE_SUSPENDED,&ThreadID);
          handles[1]=CreateFile("CONIN$",GENERIC_READ|GENERIC_WRITE,FILE_SHARE_READ|FILE_SHARE_WRITE,NULL,OPEN_EXISTING,0,NULL);
          if(handles[0]&&handles[1])
          {
            ResumeThread(handles[0]);
            if(WaitForMultipleObjects(sizeof(handles)/sizeof(handles[0]),handles,FALSE,INFINITE)==(WAIT_OBJECT_0+1))
              InterlockedIncrement((LONG *)&Stop);
            WaitForSingleObject(handles[0],INFINITE);
            if(!GetExitCodeThread(handles[0],&SearchOk)) SearchOk=FALSE;
          }
        }

        if( SearchOk && WordCount < WordsToFindCnt )
        {
            DoPartialCompletion( );

//            if( !PartialCompletion || DoPartialCompletion() )
//            {
                int PreWordLen = WordLen;

                strcat( (char *)Word, &WordList[0].Text[PreWordLen] );
                WordLen = strlen( (char *)Word );

                memcpy( RewritedText, PutWord(), WordLen - PreWordLen );

                if( (AutoAdded = WordLen - PreWordLen) > 0 )
                {
                    Colorize( );
                    EditorControl( ECTL_REDRAW, 0 );
                };
//            };
        };

        WordsToFindCnt--;
    };

    return TRUE;
};

void TAutoCompletion::DeleteVariant(void)
{
    if( AutoAdded > 0 )
    {
        if( !RewritedText[0] )
        {
            for( ; AutoAdded; AutoAdded-- )
                EditorControl( ECTL_DELETECHAR, NULL );
        }
        else
        {
            struct EditorGetString gs;
            struct EditorSetString ss;

            gs.StringNumber=-1; // current string
            EditorControl(ECTL_GETSTRING,&gs);

            //FIXME
            memcpy( (void *)&gs.StringText[WordPos+WordLen-AutoAdded], RewritedText, AutoAdded );

            ss.StringNumber = -1;
            ss.StringText = (char *)gs.StringText;
            ss.StringEOL = (char *)gs.StringEOL;
            ss.StringLength = gs.StringLength;
            Info.EditorControl( ECTL_SETSTRING, &ss );
        };

        Colorize( );
        EditorControl( ECTL_REDRAW, 0 );
        AutoAdded = 0;
        RewritedText[0] = 0;
    };
};

void TAutoCompletion::Colorize(void)
{
    struct EditorInfo ei;
    EditorControl( ECTL_GETINFO, &ei );

    struct EditorColor ec;
    ec.StringNumber = -1;
    ec.StartPos = ei.CurPos;
    ec.EndPos = ei.CurPos + AutoAdded - 1;
    ec.Color = AutoAdded ? Color : 0;

    EditorControl( ECTL_ADDCOLOR, &ec );
};

int TAutoCompletion::ProcessEditorInput(const INPUT_RECORD *Rec)
{
  unsigned char c;
  EditorInfo ei;
  BOOL IgnoreThisEvent=FALSE;
  if(Rec->EventType==MOUSE_EVENT&&Rec->Event.MouseEvent.dwButtonState)
  {
    DeleteVariant();
    return IgnoreThisEvent;
  }
  if(Rec->EventType==KEY_EVENT)
  {
    if(Rec->Event.KeyEvent.bKeyDown==TRUE||Rec->Event.KeyEvent.dwControlKeyState==0x4000000)
    {
      CheckCursor=false;
      if(AutoAdded&&Rec->Event.KeyEvent.wVirtualKeyCode!=0&&Rec->Event.KeyEvent.wVirtualScanCode!=0)
      {
        if(FSF.FarInputRecordToKey(Rec)==AcceptKey)
        {
          IgnoreThisEvent=AcceptVariant();
        }
        else if(Rec->Event.KeyEvent.wVirtualKeyCode!=VK_CONTROL&&Rec->Event.KeyEvent.wVirtualKeyCode!=VK_SHIFT&&Rec->Event.KeyEvent.wVirtualKeyCode!=VK_MENU)
          DeleteVariant();
      };
      if(Rec->Event.KeyEvent.dwControlKeyState==0x4000000)
      {
        INPUT_RECORD NewRec=*Rec;
        NewRec.Event.KeyEvent.dwControlKeyState=0;
        NewRec.Event.KeyEvent.wVirtualKeyCode=0;
        NewRec.Event.KeyEvent.wVirtualKeyCode=0;
        HANDLE console=CreateFile("CONIN$",GENERIC_READ|GENERIC_WRITE,FILE_SHARE_READ|FILE_SHARE_WRITE,NULL,OPEN_EXISTING,0,NULL);
        if(console!=INVALID_HANDLE_VALUE)
        {
          DWORD written;
          WriteConsoleInput(console,&NewRec,1,&written);
          CloseHandle(console);
        }
      }
      return IgnoreThisEvent;
    };
    Info.EditorControl(ECTL_GETINFO,&ei);
    if(CheckCursor)
    {
      if(OldRow!=ei.CurLine||OldCol!=ei.CurPos)
      {
        EditorSetPosition esp={-1,-1,-1,-1,-1,-1};
        esp.CurLine=OldRow;
        esp.CurPos=OldCol;
        Info.EditorControl(ECTL_SETPOSITION,&esp);
        DeleteVariant();
        esp.CurLine=ei.CurLine;
        esp.CurPos=ei.CurPos;
        esp.TopScreenLine=ei.TopScreenLine;
        esp.LeftPos=ei.LeftPos;
        Info.EditorControl(ECTL_SETPOSITION,&esp);
        CheckCursor=false;
        Colorize();
        EditorControl(ECTL_REDRAW,0);
        return IgnoreThisEvent;
      }
    }
    else
    {
      CheckCursor=true;
      OldRow=ei.CurLine;
      OldCol=ei.CurPos;
    }
    c=Rec->Event.KeyEvent.uChar.AsciiChar;
    if(!MyIsAlpha(c)||(Rec->Event.KeyEvent.dwControlKeyState&(LEFT_ALT_PRESSED|LEFT_CTRL_PRESSED|RIGHT_ALT_PRESSED|RIGHT_CTRL_PRESSED)))
      return IgnoreThisEvent;
    PutVariant();
    EditorControl(ECTL_REDRAW,0);
  }
  return IgnoreThisEvent;
}

int TAutoCompletion::ProcessEditorEvent(int Event, void *Param)
{
    switch(Event)
    {
        case EE_REDRAW:
            if( AutoAdded )
                Colorize( );
            break;

        case EE_SAVE:
            DeleteVariant( );
            break;

        case EE_READ:
            if( AutoAdded )
            {
                AutoAdded = 0;
                RewritedText[0] = 0;
            };

    }
    return 0;
}

BOOL TAutoCompletion::AcceptVariant(void)
{
    BOOL Accepted = FALSE;
    if( AutoAdded )
    {
        AutoAdded=0;
        RewritedText[0] = 0;
        Colorize( );
        SetCurPos(WordPos + WordLen);
        if( PartialCompletion )
            PutVariant( );
        EditorControl( ECTL_REDRAW, NULL );
        Accepted = TRUE;
    };

    return Accepted;
};

BOOL TAutoCompletion::CompleteWord(void)
{
    BOOL WasCompleted = FALSE;

    if( AutoAdded )
    {
        if( AcceptFromMenu )
        {
            AcceptVariant( );
            WasCompleted = TRUE;
        }
        else
            DeleteVariant( );
    }

    return WasCompleted;
};

void TAutoCompletion::GetDialogItems(void)
{
    TCompletion::GetDialogItems( );

    AcceptFromMenu = DialogItems[IAcceptFromMenu].Selected;

    MinPreWordLen  = FSF.atoi( DialogItems[IMinPreWordLen].Data );
    Color=DialogItems[IColor-1].Flags&0xFF;

    int TempKey = FSF.FarNameToKey( DialogItems[IAcceptKey].Data );
    AcceptKey   = TempKey > 0 ? TempKey : AcceptKey;
};

void TAutoCompletion::SetDialogItems(void)
{
    TCompletion::SetDialogItems( );

    int Msgs[]={
                  MAcceptFromMenu,
                  MMinPreWordLen, MMinPreWordLen,

                  MExample, MColor,
                  MAcceptKey, MAcceptKey,
                  MAcceptKeyCfg,
               };
    int DialogElements[][4]={
                    {DI_CHECKBOX,  3, 15,  0  }, // AcceptFromMenu
                    {DI_TEXT,      6, 16,  0  }, //
                    {DI_FIXEDIT,   3, 16,  4  }, // MinPreWordLen
                    {DI_TEXT,      0, 17,  0  }, //
                    {DI_BUTTON,    3, 17,  4  }, // Color
                    {DI_TEXT,      3, 19,  0  }, //
                    {DI_FIXEDIT,   3, 20, 28  }, // AcceptKey
                    {DI_BUTTON,   30, 20,  0  }, // AcceptKeyCfg
                   };

    for( unsigned int i=0; i < (sizeof(Msgs)/sizeof(Msgs[0])); i++ )
    {
        DialogItems[i+CMPL_DIALOG_ITEMS].Type=DialogElements[i][0];
        DialogItems[i+CMPL_DIALOG_ITEMS].X1=DialogElements[i][1];
        DialogItems[i+CMPL_DIALOG_ITEMS].Y1=DialogElements[i][2];
        DialogItems[i+CMPL_DIALOG_ITEMS].X2=DialogElements[i][3];
        DialogItems[i+CMPL_DIALOG_ITEMS].Y2=DialogElements[i][4];
        DialogItems[i+CMPL_DIALOG_ITEMS].Focus=0;
        DialogItems[i+CMPL_DIALOG_ITEMS].Selected=0;
        DialogItems[i+CMPL_DIALOG_ITEMS].Flags=0;
        DialogItems[i+CMPL_DIALOG_ITEMS].DefaultButton=0;
        strcpy( DialogItems[i+CMPL_DIALOG_ITEMS].Data, GetMsg( Msgs[i] ) ); //   - 
    };

    DialogItems[IColor-1].X1=DialogItems[IColor].X1+strlen(DialogItems[IColor].Data)+4;
    DialogItems[IColor-1].Flags=DIF_SETCOLOR|Color;

    DialogItems[IAcceptFromMenu].Selected = AcceptFromMenu;

    //     
    FSF.sprintf( DialogItems[IMinPreWordLen].Data, "%X", MinPreWordLen );

    FSF.FarKeyToName( AcceptKey, DialogItems[IAcceptKey].Data, 0 );
    DialogItems[IAcceptKey].X2 = DialogWidth - strlen( GetMsg( MAcceptKeyCfg ) ) - 8;
    DialogItems[IAcceptKeyCfg].X1 = DialogWidth - strlen( GetMsg( MAcceptKeyCfg ) ) - 6;

    strcpy( DialogItems[ICfg].Data, GetMsg( MAutoCfg ) ); // 
};

int TAutoCompletion::ProcessDlgKey( int ItemNumber )
{
    int theRet = 0;

    if( ItemNumber == IAcceptKeyCfg )
    {
        struct FarDialogItem DialogFrame;

        strcpy( DialogFrame.Data, GetMsg( MPressDesiredKey ) );
        DialogFrame.Type=DI_DOUBLEBOX;
        DialogFrame.X1=1;
        DialogFrame.Y1=1;
        DialogFrame.X2=strlen( DialogFrame.Data ) + 4;
        DialogFrame.Y2=3;
        DialogFrame.Focus=1;
        DialogFrame.Selected=1;
        DialogFrame.Flags=DIF_BOXCOLOR;
        DialogFrame.DefaultButton=1;

        AcceptKeyText = DialogItems[IAcceptKey].Data;
        Info.DialogEx( Info.ModuleNumber, -1, -1, strlen( DialogFrame.Data ) + 6, 5, ConfigHelpTopic, &DialogFrame,
                       1, 0, 0, GetKey, 0 );
        theRet = -1;
    };
    if(ItemNumber==IColor)
    {
      int bg=(DialogItems[IColor-1].Flags&0xF0)>>4,fg=DialogItems[IColor-1].Flags&0x0F;
      if(SelectColor(&fg,&bg))
        DialogItems[IColor-1].Flags=(DialogItems[IColor-1].Flags&0xFFFFFF00)|(bg<<4)|fg;
      theRet = -1;
    }

    return theRet;
};

long WINAPI GetKey( HANDLE hDlg, int Msg, int Param1, long Param2 )
{
    if( Msg == DM_KEY )
    {
        FSF.FarKeyToName( Param2, AcceptKeyText, 0 );
        Info.SendDlgMessage( hDlg, DM_CLOSE, -1, 0 );
    };

    return Info.DefDlgProc( hDlg, Msg, Param1, Param2);
};
