#ifndef __ACompl_H
#define __ACompl_H

#include "Cmpl.hpp"
#include <wincon.h>

class TAutoCompletion: public TCompletion
{
public:
    BOOL AcceptFromMenu;

    int AcceptKey;
    int Color;

    int AutoAdded;
    char RewritedText[MAX_WORD_LEN];

    bool CheckCursor;
    int OldRow,OldCol;

    TAutoCompletion(void);
    ~TAutoCompletion();

    void GetOptions(void);
    void SetOptions(void);

    void Validate(void);

    void GetDialogItems(void);
    void SetDialogItems(void);
    int ProcessDlgKey( int ItemNumber );

    BOOL PutVariant(void);
    void DeleteVariant(void);
    void Colorize(void);
    int ProcessEditorInput(const INPUT_RECORD *Rec);
    int ProcessEditorEvent(int Event, void *Param);
    BOOL AcceptVariant(void);
    BOOL CompleteWord(void);
};

#define ACMPL_DIALOG_ITEMS (IAcceptKeyCfg+1)

enum
{
    IAcceptFromMenu = CMPL_DIALOG_ITEMS,      // AcceptFromMenu
    IMinPreWordLen = CMPL_DIALOG_ITEMS + 2,   // MinPreWordLen
                                              //
    IColor = CMPL_DIALOG_ITEMS + 4,           // Color
    IAcceptKey = CMPL_DIALOG_ITEMS + 6,       // AcceptKey
    IAcceptKeyCfg,                            // AcceptKeyCfg
};

extern bool SelectColor(int *fg,int *bg);

#endif