#ifndef __Complete_H
#define __Complete_H

#include "EditCmpl.hpp"

#define MAX_WORD_LEN 120
#define MAX_WORD_CNT 100

#define MAX(a, b)  (((a) > (b)) ? (a) : (b))
#define MIN(a, b)  (((a) < (b)) ? (a) : (b))

class TCompletion
{
public:
    unsigned char Word[MAX_WORD_LEN];

    volatile LONG Stop;

    BOOL WorkInsideWord;
    BOOL BrowseDownward;
    BOOL CaseSensitive;
    BOOL ConsiderDigitAsChar;
    BOOL PartialCompletion;
    BOOL AddTrailingSpace;

    int  MinPreWordLen;
    int  MinWordLen;
    int  BrowseLineCnt;
    int  WordsToFindCnt;
    int  SortListCount;
    char AdditionalLetters[80];

    unsigned char AsteriskSymbol;

    char RegKey[80];
    char ConfigHelpTopic[80];
    char ShortCuts[80];

    int WordLen;
    int WordCount;
    int MaxWordLen;
    int WordPos;
    FarMenuItem *WordList;
    FarDialogItem *DialogItems;
    int DialogItemsCnt;
    int DialogWidth;
    int DialogHeight;

    TCompletion(void);
    virtual ~TCompletion();

    virtual void GetOptions(void);
    virtual void SetOptions(void);

    virtual void Validate(void);

    int GetCoincidenceLen(void);

    virtual void GetDialogItems(void);
    virtual void SetDialogItems(void);

    virtual void ShowDialog(void);
    //  0   
    virtual int ProcessDlgKey( int ItemNumber );

    int GetPreWord(void);
    int DoSearch(void);
    BOOL DoPartialCompletion(void);
    char *PutWord(void);
    void SetCurPos(int NewPos);

    int AddWords(char *Line, int Len, int Direction);
    int AddWord(char *Word);
    BOOL InsertWordIntoList(char *NewWord);
    char *FindWordStart(char *Line, int Len);

    void SortList(void);

    BOOL MyIsAlpha(int c);
};

#define CMPL_DIALOG_ITEMS (IAddTrailingSpace + 1)
enum
{
    ICfg, IOk, ICancel,

    IWorkInsideWord,
    ICaseSensitive,

    IConsiderDigitAsChar,
    IAdditionalLetters = 7,

    IBrowseDownward,
    IBrowseLineCnt = 10,
    IWordsToFindCnt = 12,
    IMinWordLen = 14,

    IPartialCompletion,
    IAddTrailingSpace,

};

#endif