/*
  EditCompletition plugin for FAR.
  Rewrited & Improved by Igor Lubimov
  E-mail: mr_july@mail.ru
*/

#include "EditCmpl.hpp"

#if defined(__GNUC__)

#ifdef __cplusplus
extern "C"{
#endif
  BOOL WINAPI DllMainCRTStartup(HANDLE hDll,DWORD dwReason,LPVOID lpReserved);
#ifdef __cplusplus
};
#endif

BOOL WINAPI DllMainCRTStartup(HANDLE hDll,DWORD dwReason,LPVOID lpReserved)
{
  return TRUE;
}

#else

extern "C"
{
    BOOL WINAPI _export LibMain(HINSTANCE hDLLInst, DWORD fdwReason, LPVOID lpvReserved)
    {
        return TRUE;
    };
};

#endif

#include "ECmplLng.h"
#include "MCmpl.hpp"
#include "ACmpl.hpp"

struct PluginStartupInfo Info;
FARSTANDARDFUNCTIONS FSF;

BOOL IsOldFAR;

TMenuCompletion *MCmpl;
TAutoCompletion *ACmpl;

const char *GetMsg(int MsgId)
{
    return(Info.GetMsg(Info.ModuleNumber,MsgId));
};

int WINAPI EditorControl(int Command, void* Param)
{
    return(Info.EditorControl(Command, Param));
};

void WINAPI _export SetStartupInfo(const struct PluginStartupInfo *Info)
{
    ::Info=*Info;
    IsOldFAR=TRUE;
    if(Info->StructSize >= (int)sizeof(struct PluginStartupInfo))
    {
//FarMessageBox(Info, "DEBUG", NULL, 0, "!!!");
        ::FSF=*Info->FSF;
        ::Info.FSF=&::FSF;
        IsOldFAR=FALSE;

        strcpy( PluginRootKey, Info->RootKey );
        strcat( PluginRootKey, "\\EditCompletion" );

//FarMessageBox(Info, "Before Constructors", NULL, 0, "Hello, World!");
//        MCmpl = (TMenuCompletion*)HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, sizeof(TMenuCompletion));
        MCmpl = new TMenuCompletion();
//FarMessageBox(Info, "After TMenuCompletion", NULL, 0, "Hello, World!");
//        ACmpl = (TAutoCompletion*)HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, sizeof(TAutoCompletion));
        ACmpl = new TAutoCompletion();
//FarMessageBox(Info, "After Constructors", NULL, 0, "Hello, World!");

        MCmpl->GetOptions( );
//FarMessageBox(Info, "SetStartupInfo1", NULL, 0, "WordsToFindCnt %d ", ACmpl->WordsToFindCnt);
        ACmpl->GetOptions( );
//FarMessageBox(Info, "SetStartupInfo2", NULL, 0, "WordsToFindCnt %d ", ACmpl->WordsToFindCnt);
//FarMessageBox(Info, "After GetOptions", NULL, 0, "WordsToFindCnt %d ", ACmpl->WordsToFindCnt);
    };
};

void WINAPI _export GetPluginInfo(struct PluginInfo *Info)
{
    if(!IsOldFAR)
    {
        Info->StructSize=sizeof(*Info);
        Info->Flags=PF_EDITOR|PF_DISABLEPANELS;
        static const char *PluginMenuStrings[1];
        // Text in Plugins Configuration menu
        PluginMenuStrings[0]=GetMsg(MEditCmpl);
        Info->PluginConfigStrings=PluginMenuStrings;
        Info->PluginConfigStringsNumber=sizeof(PluginMenuStrings)/sizeof(PluginMenuStrings[0]);
        // Text in Plugins menu
        Info->PluginMenuStrings=PluginMenuStrings;
        Info->PluginMenuStringsNumber=sizeof(PluginMenuStrings)/sizeof(PluginMenuStrings[0]);
    };
};

HANDLE WINAPI _export OpenPlugin(int OpenFrom,int Item)
{
    if(!IsOldFAR)
        ShowMenu( );

    return (INVALID_HANDLE_VALUE);
};

int WINAPI _export Configure(int ItemNumber)
{
    if(!IsOldFAR)
        ShowMenu( 2 );

    return FALSE;
};

int WINAPI _export ProcessEditorEvent(int Event, void *Param)
{
    int ret = 0;

    if(!IsOldFAR)
        ret = ACmpl->ProcessEditorEvent( Event, Param );

    return ret;
};

int WINAPI _export ProcessEditorInput(const INPUT_RECORD *Rec)
{
    int ret = 0;

    if(!IsOldFAR)
        ret =  ACmpl->ProcessEditorInput( Rec );
    return ret;
};

void WINAPI _export ExitFAR(void)
{
    if(!IsOldFAR)
    {
        delete ACmpl;
        delete MCmpl;
    };
}

int ShowMenu(int Offset)
{
    int i, SelectedItem = 0;
    int Msgs[]={ MComplete, MComplete, MMenuCfg, MAutoCfg };
    struct FarMenuItem Items[sizeof(Msgs)/sizeof(Msgs[0])];

    for( i=0; i < (int)(sizeof(Msgs)/sizeof(Msgs[0])); i++ )
    {
        Items[i].Selected=0;
        Items[i].Checked=0;
        Items[i].Separator=0;
        strcpy(Items[i].Text,GetMsg(Msgs[i])); //   - 
    };

    Items[1].Text[0] = 0;
    Items[1].Separator = TRUE;

    i = 0;

    do
    {
        Items[SelectedItem].Selected = TRUE;

        i=Info.Menu( Info.ModuleNumber, -1, -1, 0, FMENU_AUTOHIGHLIGHT|FMENU_WRAPMODE, GetMsg(MEditCmpl),
                     NULL, // bottom
                     "Contents", // helptopic
                     NULL,NULL, // breakkeys, breakcode
                     &Items[Offset], sizeof(Msgs)/sizeof(Msgs[0]) - Offset );

        Items[SelectedItem].Selected = FALSE;
        SelectedItem = i;

        if( i >= 0 )
            i += Offset;

        switch( i )
        {
            case 0: // "OK"
                if( !ACmpl->CompleteWord( ) )
                    MCmpl->CompleteWord( );
                    break;

            case 2: // Menu
                    MCmpl->ShowDialog( );
                    break;

            case 3: // Auto
                    ACmpl->ShowDialog( );
        }
    }while( i > 0 );

    return TRUE;
};
