/*
FAR plugins programing - Encyclopedia of Developer

FarMessageBox.cpp

 FarMessageBox      MessageBox  Win API.

Valentin Skirdin <vskirdin@mail.ru>
*/


#include "FMsgBox.hpp"

char *_stdButton[7]={
  "Ok",
  "Cancel",
  "Abort",
  "Retry",
  "Ignore",
  "Yes",
  "No"
};

/*
  :
"Ok;Cancel;Abort;Retry;Ignore;Yes;No"
*/
void InitStdButtons(char *buts)
{
  char *p=strtok(buts, ";");
  int mbuttons=0;
  while(p && mbuttons < 7)
  {
    _stdButton[mbuttons++]=p;
    p=strtok(NULL, ";");
  }
}


int FarMessageBox(struct PluginStartupInfo *psi,
                  char *caption,
                  char *help,
                  UINT typeMsg,
                  char *fmtText,
                  ...)
{
  char *buffOut,*msg,*msg0;
  va_list argptr;
  unsigned int Flags=0;
  int items=2,buttonsCount=1;

  char *Msg[16]; //????

  if(psi)
  {
    if((buffOut=(char *)HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, 512)) != NULL)
    {
      Msg[0]=caption;
      if((typeMsg & 0xF0) == MB_ICONWARNING)
      {
        Flags|=FMSG_WARNING;
      }
      if((typeMsg & 0xF0) == MB_ICONERROR)
      {
        Flags|=FMSG_ERRORTYPE|FMSG_WARNING;
      }
      va_start(argptr, fmtText);
      wvsprintf(buffOut,fmtText, argptr);
      va_end(argptr);

      //       
      msg0=msg=buffOut;
      Msg[items-1]=msg0;
      while ((msg = strchr(msg, '\n')) != NULL)
      {
        if(items > 12)
          break;
        *msg='\0';
        ++msg;
        if(*msg == '\0')
          break;
        ++items;
        Msg[items-1]=msg;
      }

      typeMsg&=0x0F;
      switch(typeMsg)
      {
        case MB_OK:
          Msg[items++]=_stdButton[0];
          break;
        case MB_OKCANCEL:
          Msg[items++]=_stdButton[0];
          Msg[items++]=_stdButton[1];
          buttonsCount++;
          break;
        case MB_ABORTRETRYIGNORE:
          Msg[items++]=_stdButton[2];
          Msg[items++]=_stdButton[3];
          Msg[items++]=_stdButton[4];
          buttonsCount+=2;
          break;
        case MB_YESNO:
          Msg[items++]=_stdButton[5];
          Msg[items++]=_stdButton[6];
          buttonsCount++;
          break;
        case MB_YESNOCANCEL:
          Msg[items++]=_stdButton[5];
          Msg[items++]=_stdButton[6];
          Msg[items++]=_stdButton[1];
          buttonsCount+=2;
          break;
        case MB_RETRYCANCEL:
          Msg[items++]=_stdButton[3];
          Msg[items++]=_stdButton[1];
          buttonsCount++;
          break;
      }

      items=psi->Message(psi->ModuleNumber,Flags,help,Msg,items,buttonsCount);
      HeapFree(GetProcessHeap(), 0, buffOut);

      if(items == -1)
        return IDCANCEL;

      switch(typeMsg)
      {
        case MB_OK:
          return IDOK;
        case MB_OKCANCEL:
          return items+1;
        case MB_ABORTRETRYIGNORE:
          return items+3;
        case MB_YESNO:
          return items+6;
        case MB_YESNOCANCEL:
          return (items == 2?IDCANCEL:items+6);
        case MB_RETRYCANCEL:
          return (items == 1?IDCANCEL:IDRETRY);
      }
    }
  }
  return IDCANCEL;
}
