#include <windows.h>
#include <stdlib.h>
#include "Locale.hpp"

int CharCompare(const void *a, const void *b)
{
    return (CompareString(LOCALE_USER_DEFAULT, SORT_STRINGSORT|NORM_IGNORECASE, (char *)a, 1, (char *)b, 1) - 2);
};

int ScanCodeCompare(const void *a, const void *b)
{
    BreakKeysItem *i1, *i2;

    i1=(BreakKeysItem *)(a);
    i2=(BreakKeysItem *)(b);

    return (i2->ScanCode-i1->ScanCode);
};

TLocale::TLocale(void)
{
    KeyboardLayoutCnt=0;
    Alphabets[0][0] = 0;
    Alphabets[1][0] = 0;
    AlphabetLengths[0] = 0;
    AlphabetLengths[1] = 0;
    BreakSymbols[0][0] = 0;
    BreakSymbols[1][0] = 0;
    BreakKeys[0][0] = 0;
    BreakKeys[1][0] = 0;
};

TLocale::~TLocale(void)
{
    KeyboardLayoutCnt=0;
};

void TLocale::GetLocales(void)
{
    int i, j;
    int VK_Scaned;
    unsigned char *IntChar, ShiftState;
    char Chr2Cnv[2];
    HKL KeyboardLayouts[MAX_KBD_LAYOUTS];
    int DefaultOnly=0;
    BreakKeysItem BreakKeysEx[MAX_KBD_LAYOUTS][MAX_BREAKKEY_CNT];
    char TempAlphabets[MAX_KBD_LAYOUTS][MAX_ALPHABET_LEN];
    int k[MAX_KBD_LAYOUTS]; // -   
    int l[MAX_KBD_LAYOUTS]; // -  

    KeyboardLayoutCnt=GetKeyboardLayoutList(MAX_KBD_LAYOUTS, KeyboardLayouts);
    DefaultOnly=!KeyboardLayoutCnt;
    if(DefaultOnly)
        KeyboardLayoutCnt=1;

    //  
    for( i=0; i < KeyboardLayoutCnt; i++ )
    {
        Alphabets[i][0] = 0;
        AlphabetLengths[i] = 0;
        BreakSymbols[i][0] = 0;
        BreakKeys[i][0] = 0;

        TempAlphabets[i][0] = 0;
        k[i]=0;
        l[i]=0;
    };
    Chr2Cnv[1]=0;
    for(i=32; i<256; i++)
    {
        for(j=0; j<KeyboardLayoutCnt; j++)
        {
            if(DefaultOnly)
                VK_Scaned=VkKeyScan(i);
            else
                VK_Scaned=VkKeyScanEx(i, KeyboardLayouts[j]);

            if(VK_Scaned<0)
                continue;
            if(IsCharAlphaNumeric(i))
            {
                //      
                Chr2Cnv[0]=i;
                CharLower(Chr2Cnv);
                if( !strchr(TempAlphabets[j], Chr2Cnv[0]) && (k[j] < MAX_ALPHABET_LEN) )
                {
                    TempAlphabets[j][k[j]++]=Chr2Cnv[0];
                    TempAlphabets[j][k[j]]=0; // trailing zero
                };
            }
            else
            {
                IntChar=(unsigned char*)(&VK_Scaned);
                //      
                IntChar[2]=IntChar[1];
                IntChar[1]=0;
                ShiftState=( 1&IntChar[2] ? 4 : 0 );
                IntChar[2]>>=1;
                IntChar[2]|=ShiftState;
                BreakKeysEx[j][l[j]].Symbol=i;
                BreakKeysEx[j][l[j]++].ScanCode=VK_Scaned;
//                BreakKeysEx[j][l[j]].Symbol=0;
//                BreakKeysEx[j][l[j]].ScanCode=0;
            };
        };
    };

    for(i=0; i<KeyboardLayoutCnt; i++)
    {
        qsort(TempAlphabets[i], k[i], 1, CharCompare);
        //      (  
        // ,    ,  '<'  ',')
        qsort(BreakKeysEx[i], l[i], sizeof(BreakKeysItem), ScanCodeCompare);
        //     
        CharToOem(TempAlphabets[i], Alphabets[i]);
        AlphabetLengths[i] = strlen( Alphabets[i] );
        for(j=0; j<l[i]; j++)
        {
            BreakSymbols[i][j]=BreakKeysEx[i][j].Symbol;
            BreakKeys[i][j]=BreakKeysEx[i][j].ScanCode;
        };
        BreakSymbols[i][j]=0;
        BreakKeys[i][j]=0;
        CharToOem(BreakSymbols[i], BreakSymbols[i]);
    };

};

int TLocale::GetStringLocale( char * String )
{
    int LocaleNumber=0;
    BOOL BelongToAlphabet;
    int i, j;

    for( i = strlen( String ) - 1; i >= 0; i-- )
    {
        LocaleNumber = 0;
        BelongToAlphabet = FALSE;

        for( j = 0; j < KeyboardLayoutCnt; j++ )
        {
            if( strchr( Alphabets[j], String[i] ) )
            {
                if( !BelongToAlphabet )
                {
                    LocaleNumber = j;
                    BelongToAlphabet = TRUE;
                }
                else
                    break;
            };

        };
        if( BelongToAlphabet && j == KeyboardLayoutCnt )
        {
            break;
        };
    };

    return LocaleNumber;
};
