#ifndef __MCompl_H
#define __MCompl_H

#include "Cmpl.hpp"
#include "Locale.hpp"

#define ADD_MENU_X 10
#define ADD_MENU_Y 4

class TMenuCompletion: public TCompletion, TLocale
{
public:
    int SingleVariantInMenu;
    int NotFoundSound;

    int LocaleNumber;

    TMenuCompletion(void);
    ~TMenuCompletion();

    void GetOptions(void);
    void SetOptions(void);

    void Validate(void);

    void GetDialogItems(void);
    void SetDialogItems(void);
    int ProcessDlgKey( int ItemNumber );

    int AddShortCuts(void);
    int ShowMenu(void);
    int DeleteShortCut( int ItemNumber );

    BOOL CompleteWord(void);
};

#define MCMPL_FIRST_TEXT (CMPL_DIALOG_ITEMS+3)
#define MCMPL_DIALOG_ITEMS (IAsteriskSymbol+1)

enum
{
    ISingleVariantInMenu = CMPL_DIALOG_ITEMS,   // SingleVariantInMenu
    INotFoundSound,                             // NotFoundSound
    ISortListCount  = MCMPL_FIRST_TEXT,         // SortListCount
    IAsteriskSymbol = MCMPL_FIRST_TEXT + 2,     // AsteriskSymbol
};

#endif